#!/bin/bash

green_color_switch_on () {
    type tput &>/dev/null && tput setaf 2 || echo "";
}

red_color_switch_on () {
    type tput &>/dev/null && tput setaf 1 || echo "";
}

color_switch_off() {
    type tput &>/dev/null && tput sgr0 || echo "";
}

if [ -f "$HOME/.vimrc" ]
then
  result="`grep -c cpptesk ~/.vimrc`"
else
  result="0"
fi

#result2=`find ../etc/vim/syntax -name *.vim`
if [ -d ../etc/vim/syntax ]
then
  case $result in
  "0" )
    cat ../etc/vim/.vimrc >> "$HOME/.vimrc"
    mkdir -p ~/.vim/syntax
    cp -f ../etc/vim/syntax/* ~/.vim/syntax/
    green_color_switch_on
    echo "[OK] C++TESK Testing Toolkit's syntax highlighting for VIM has been installed."
    color_switch_off
  ;;
  * )
    cp -f ../etc/vim/syntax/* ~/.vim/syntax/
    green_color_switch_on
    echo "[OK] C++TESK Testing Toolkit's syntax highlighting for VIM has been updated."
    color_switch_off
  ;;
  esac
else
    red_color_switch_on
    echo "[FAILED] Some problems with syntax highlighting for VIM have occured. Ask support!"
    color_switch_off
fi
