/*
 * Copyright 2010-2013 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: Types for diagnostics subsystem
///////////////////////////////////////////////////////////////////////////////

#pragma once

enum ErrorTypes
{
    DATA_TIME_IFACE_ERROR = 7,
    DATA_TIME_ERROR       = 6,
    DATA_IFACE_ERROR      = 5,
    TIME_IFACE_ERROR      = 3,
    DATA_ERROR            = 4,
    TIME_ERROR            = 2,
    IFACE_ERROR           = 1,
    NONE_ERROR            = 0
};

enum CollapseType {
    NO_COLLAPSE = 0,
    NORMAL_COLLAPSE = 1,
    FUZZY_COLLAPSE = 2
};

enum PrintTypes
{
    TITLE_DATA_MESSAGE =  0, // print title
    SPEC_DATA_MESSAGE  =  1, // print spec
    IMPL_DATA_MESSAGE  =  2 // print impl
};

/// Standard: 80 characters in a message line
#define LINE_SIZE_DIAG_MESSAGE 80

#ifndef uint
typedef unsigned int uint;
#endif
