/*
 * Copyright 2010-2013 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: Trace printer for Diagnostics Reactions
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <fstream>

#include <hw/report/trace_printer.hpp>

namespace cpptesk {
namespace hw {
namespace report {

class ReactionPrinter: public TracePrinter
{
public:
    ReactionPrinter();
    virtual ~ReactionPrinter();

    virtual void print(std::ostream &out, const cpptesk::hw::diagnostics::ReactionUnitVector &reactions);
    void print(std::string _file_name, const cpptesk::hw::diagnostics::ReactionUnitVector &reactions);
    
private:
    /// Reactions vector for print
    cpptesk::hw::diagnostics::ReactionUnitVector _reaction_units;
    
    /// File for print
    std::fstream *_file_trace;
    
    void _describe_reaction(std::ostream &out, uint id);
    void _describe_parent(std::ostream &out, uint id, bool first);
    void _print_explanation(std::ostream &out, Reaction &reaction);
};

}}}
