" C++TESK syntax file
" Language:	C++TESK
" Maintainer:	Alexander Kamkin <kamkin@ispras.ru>
" Last Change:	2011 May 23

" For version 5.x: Clear all syntax items
" For version 6.x: Quit when a syntax file was already loaded
if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

" Read the C++ syntax to start with
if version < 600
  so <sfile>:p:h/cpp.vim
else
  runtime! syntax/cpp.vim
  unlet b:current_syntax
endif

" C++TESK: Model
syn keyword cppteskTypeModel	CPPTESK_MODEL MODEL

syn keyword cppteskDeclIface	CPPTESK_DECLARE_IFACE DECLARE_IFACE CPPTESK_DECLARE_INPUT DECLARE_INPUT CPPTESK_DECLARE_OUTPUT DECLARE_OUTPUT
syn keyword cppteskStmtIface1	CPPTESK_ADD_IFACE ADD_IFACE CPPTESK_ADD_INPUT ADD_INPUT CPPTESK_ADD_OUTPUT ADD_OUTPUT
syn keyword cppteskStmtIface2	CPPTESK_CAPTURE_IFACE CAPTURE_IFACE CPPTESK_RELEASE_IFACE RELEASE_IFACE

syn keyword cppteskDeclProcess	CPPTESK_DECLARE_PROCESS DECLARE_PROCESS CPPTESK_DEFINE_PROCESS DEFINE_PROCESS
syn keyword cppteskDeclStimulus	CPPTESK_DECLARE_STIMULUS DECLARE_STIMULUS CPPTESK_DEFINE_STIMULUS DEFINE_STIMULUS
syn keyword cppteskDeclPre	CPPTESK_DECLARE_PRECONDITION DECLARE_PRECONDITION CPPTESK_DEFINE_PRECONDITION DEFINE_PRECONDITION
syn keyword cppteskDeclStimPre	CPPTESK_DECLARE_STIMULUS_WITH_PRE DECLARE_STIMULUS_WITH_PRE
syn keyword cppteskDeclReaction	CPPTESK_DECLARE_REACTION DECLARE_REACTION CPPTESK_DEFINE_REACTION DEFINE_REACTION

syn keyword cppteskStmtParam	CPPTESK_GET_PROCESS GET_PROCESS CPPTESK_GET_IFACE GET_IFACE CPPTESK_GET_MESSAGE GET_MESSAGE PARALLEL SEQUENTIAL
syn keyword cppteskStmtCast	CPPTESK_CAST_MESSAGE CAST_MESSAGE CPPTESK_CONST_CAST_MESSAGE CONST_CAST_MESSAGE

syn keyword cppteskTypeMessage	CPPTESK_MESSAGE MESSAGE
syn keyword cppteskDeclField	CPPTESK_DECLARE_FIELD DECLARE_FIELD CPPTESK_DECLARE_MASKED_FIELD DECLARE_MASKED_FIELD CPPTESK_DECLARE_BIT DECLARE_BIT
syn keyword cppteskStmtField	CPPTESK_ADD_FIELD ADD_FIELD CPPTESK_ADD_INCOMPARABLE_FIELD ADD_INCOMPARABLE_FIELD

syn keyword cppteskStmtTiming	CPPTESK_CYCLE CYCLE CPPTESK_DELAY DELAY CPPTESK_WAIT WAIT CPPTESK_WAIT_TIMEOUT WAIT_TIMEOUT
syn keyword cppteskStmtTimeout	CPPTESK_SET_REACTION_TIMEOUT SET_REACTION_TIMEOUT CPPTESK_SET_UNEXPECTED_REACTION_TIMEOUT SET_UNEXPECTED_REACTION_TIMEOUT
syn keyword cppteskStmtPriority	CPPTESK_GET_PRIORITY GET_PRIORITY CPPTESK_SET_PRIORITY SET_PRIORITY

syn keyword cppteskStmtStart	CPPTESK_START START CPPTESK_START_PROCESS START_PROCESS CPPTESK_START_STIMULUS START_STIMULUS CPPTESK_START_REACTION START_REACTION
syn keyword cppteskStmtStop	CPPTESK_STOP STOP CPPTESK_STOP_PROCESS STOP_PROCESS CPPTESK_STOP_STIMULUS STOP_STIMULUS CPPTESK_STOP_REACTION STOP_REACTION

syn keyword cppteskStmtSend	CPPTESK_SEND_REACTION SEND_REACTION
syn keyword cppteskStmtRecv	CPPTESK_RECV_STIMULUS RECV_STIMULUS
syn keyword cppteskStmtCall	CPPTESK_CALL_PROCESS CALL_PROCESS CPPTESK_CALL_OUTPUT_LISTENER CALL_OUTPUT_LISTENER

" C++TESK: Adapter
syn keyword cppteskTypeAdapter	CPPTESK_ADAPTER ADAPTER CPPTESK_MEDIA MEDIA
syn keyword cppteskTypeVeritool	CPPTESK_VERITOOL_ADAPTER VERITOOL_ADAPTER CPPTESK_VERITOOL_MEDIA VERITOOL_MEDIA

syn keyword cppteskStmtAdapter	CPPTESK_SET_INPUT_ADAPTER SET_INPUT_ADAPTER CPPTESK_SET_OUTPUT_ADAPTER SET_OUTPUT_ADAPTER CPPTESK_SET_OUTPUT_ADAPTER_NO_LISTENER SET_OUTPUT_ADAPTER_NO_LISTENER CPPTESK_SET_OUTPUT_ADAPTER_USER_LISTENER SET_OUTPUT_ADAPTER_USER_LISTENER
syn keyword cppteskDeclArbiter	CPPTESK_DECLARE_ARBITER DECLARE_ARBITER
syn keyword cppteskStmtArbiter 	CPPTESK_SET_ARBITER SET_ARBITER
syn keyword cppteskTypeArbiter	CPPTESK_FIFO_ARBITER FIFO_ARBITER CPPTESK_PRIORITY_ARBITER PRIORITY_ARBITER

syn keyword cppteskDeclListener	CPPTESK_DEFINE_BASIC_OUTPUT_LISTENER DEFINE_BASIC_OUTPUT_LISTENER

syn keyword cppteskStmtReaction	CPPTESK_WAIT_REACTION WAIT_REACTION CPPTESK_NEXT_REACTION NEXT_REACTION

syn keyword cppteskSetDbg       CPPTESK_SET_DEBUG_LEVEL SET_DEBUG_LEVEL CPPTESK_SET_DEBUG_STYLE SET_DEBUG_STYLE CPPTESK_SET_DEBUG_INDENT SET_DEBUG_INDENT CPPTESK_DEBUG_INDENT_BEGIN DEBUG_INDENT_BEGIN CPPTESK_DEBUG_INDENT_END DEBUG_INDENT_END CPPTESK_START_DEBUG_INDENT START_DEBUG_INDENT CPPTESK_STOP_DEBUG_INDENT STOP_DEBUG_INDENT CPPTESK_SET_DEBUG_LOGFILE SET_DEBUG_LOGFILE
syn keyword cppteskDbgPrint     CPPTESK_DEBUG_PRINT DEBUG_PRINT CPPTESK_DEBUG_PRINTF DEBUG_PRINTF CPPTESK_COLORED_DEBUG_PRINT COLORED_DEBUG_PRINT CPPTESK_COLORED_DEBUG_PRINTF COLORED_DEBUG_PRINTF CPPTESK_COLORED_DEBUG_PRINT_FILE_LINE COLORED_DEBUG_PRINT_FILE_LINE CPPTESK_COLORED_DEBUG_PRINTF_FILE_LINE COLORED_DEBUG_PRINTF_FILE_LINE CPPTESK_DEBUG_NONE DEBUG_NONE CPPTESK_DEBUG_ERROR DEBUG_ERROR CPPTESK_DEBUG_FAIL DEBUG_FAIL CPPTESK_DEBUG_WARNING DEBUG_WARNING CPPTESK_DEBUG_WARN DEBUG_WARN CPPTESK_DEBUG_MESSAGE DEBUG_MESSAGE CPPTESK_DEBUG_USER DEBUG_USER CPPTESK_DEBUG_BASIC DEBUG_BASIC CPPTESK_DEBUG_INFO DEBUG_INFO CPPTESK_DEBUG_DETAILED DEBUG_DETAILED CPPTESK_DEBUG_MORE DEBUG_MORE CPPTESK_DEBUG_ALL DEBUG_ALL CPPTESK_DEBUG_INTERNAL DEBUG_INTERNAL CPPTESK_DEBUG_TOOL DEBUG_TOOL
syn keyword cppteskUsrListener  CPPTESK_DECLARE_LISTENER DECLARE_LISTENER CPPTESK_DEFINE_LISTENER DEFINE_LISTENER CPPTESK_START_LISTENER START_LISTENER CPPTESK_CYCLE_BEFORE_CHECKING CYCLE_BEFORE_CHECKING CPPTESK_IS_REACTION_TAKEN IS_REACTION_TAKEN CPPTESK_DESERIALIZE_UNEXPECTED_REACTIONS DESERIALIZE_UNEXPECTED_REACTIONS CPPTESK_STOP_LISTENER STOP_LISTENER

" C++TESK: Scenario
syn keyword cppteskTypeScenario CPPTESK_SCENARIO SCENARIO
syn keyword cppteskStmtScenario CPPTESK_ADD_SCENARIO_METHOD ADD_SCENARIO_METHOD SCENARIO_METHOD

syn keyword cppteskStmtIterate	CPPTESK_ITERATION_BEGIN ITERATION_BEGIN IBEGIN CPPTESK_ITERATION_END ITERATION_END IEND
syn keyword cppteskStmtVariable	CPPTESK_ITERATION_VARIABLE ITERATION_VARIABLE IVAR
syn keyword cppteskStmtAction	CPPTESK_ITERATION_ACTION ITERATION_ACTION IACTION CPPTESK_ITERATION_YIELD ITERATION_YIELD YIELD

" C++TESK: Coverage
syn keyword cppteskDeclEnumCov	CPPTESK_DEFINE_ENUMERATED_COVERAGE DEFINE_ENUMERATED_COVERAGE ENUM_COV
syn keyword cppteskDeclAliasCov	CPPTESK_DEFINE_ALIAS_COVERAGE DEFINE_ALIAS_COVERAGE ALIAS_COV
syn keyword cppteskDeclCompCov	CPPTESK_DEFINE_COMPOSED_COVERAGE DEFINE_COMPOSED_COVERAGE COMP_COV
syn keyword cppteskDeclExclCov	CPPTESK_DEFINE_COMPOSED_COVERAGE_EXCLUDING DEFINE_COMPOSED_COVERAGE_EXCLUDING COMP_COV_EXCL

" C++TESK: Model
hi link cppteskTypeModel	cppStructure

hi link cppteskDeclIface	cppStatement
hi link cppteskStmtIface1	cppStatement
hi link cppteskStmtIface2	cppStatement

hi link cppteskDeclProcess	cppStatement
hi link cppteskDeclStimulus	cppStatement
hi link cppteskDeclPre		cppStatement
hi link cppteskDeclStimPre	cppStatement
hi link cppteskDeclReaction	cppStatement

hi link cppteskStmtParam	cppStatement
hi link cppteskStmtCast		cppStatement

hi link cppteskTypeMessage	cppStructure
hi link cppteskDeclField	cppStatement
hi link cppteskStmtField	cppStatement

hi link cppteskStmtTiming	cppStatement
hi link cppteskStmtTimeout	cppStatement
hi link cppteskStmtPriority	cppStatement

hi link cppteskStmtStart	cppStatement
hi link cppteskStmtStop		cppStatement

hi link cppteskStmtSend		cppStatement
hi link cppteskStmtRecv		cppStatement
hi link cppteskStmtCall		cppStatement

" C++TESK: Adapter
hi link cppteskTypeAdapter	cppStructure
hi link cppteskTypeVeritool	cppStructure

hi link cppteskStmtAdapter	cppStatement

hi link cppteskDeclArbiter	cppStatement
hi link cppteskStmtArbiter	cppStatement
hi link cppteskTypeArbiter	cppType

hi link cppteskDeclListener	cppStatement

hi link cppteskStmtReaction	cppStatement

hi link cppteskSetDbg           cppStatement
hi link cppteskDbgPrint         cppStatement
hi link cppteskUsrListener      cppStatement
" C++TESK: Scenario
hi link cppteskTypeScenario	cppStructure
hi link cppteskStmtScenario	cppStatement

hi link cppteskStmtIterate	cppStatement
hi link cppteskStmtVariable	cppStatement
hi link cppteskStmtAction	cppStatement

" C++TESK: Coverage
hi link cppteskDeclEnumCov	cppStatement
hi link cppteskDeclAliasCov	cppStatement
hi link cppteskDeclCompCov	cppStatement
hi link cppteskDeclExclCov	cppStatement

let b:current_syntax = "cpptesk"

" vim: ts=8
