/*
 * Generated by veritool: Copyright (c) 2009-2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 *
 * http://hardware.ispras.ru
 */

`timescale 1 ns/1 ps

module testbench();

    parameter HALF_CYCLE_DELAY = 5;
    parameter RESET_CYCLE_NUMBER = 3;
    parameter INC_CYCLE_ACCORD_TO_FRONT_OF_CLK = 1;

    reg clk;
    reg inc;
    reg inc_reg;
    reg rst;
    reg run;
    wire [7:0] data;

    always @(posedge clk) begin
        inc_reg <= inc;
    end

    count target (
        .clk(clk),
        .inc(inc_reg),
        .rst(rst),
        .data(data)
    );

    reg [63 : 0] CYCLE;
    reg [256 * 8 : 1] argv;
    reg [64 * 8 : 1] pstring;
    reg [64 * 8 : 1] dumpfilename;
    reg netscen;

    task cycle;
    input inc_CYCLE;
    begin
        clk = 0; #(HALF_CYCLE_DELAY);
        if(inc_CYCLE == 1 && INC_CYCLE_ACCORD_TO_FRONT_OF_CLK == 1) CYCLE = CYCLE + 1;
        clk = 1; #(HALF_CYCLE_DELAY);
        if(inc_CYCLE == 1 && INC_CYCLE_ACCORD_TO_FRONT_OF_CLK == 0) CYCLE = CYCLE + 1;
    end
    endtask

    task delay;
    input inc_CYCLE;
    input [31:0] number_of_cycles;
    reg [31:0] i;
    begin
        i = 0;
        while(i < number_of_cycles)
        begin
            cycle(inc_CYCLE);
            i = i + 1;
        end
    end
    endtask

    initial begin
        if(!$value$plusargs("dumpfile=%s", dumpfilename)) begin
            dumpfilename="testbench.vcd";
        end
        if(!$test$plusargs("nodumpfile")) begin
            $dumpfile(dumpfilename);
            $dumpvars(1, testbench);
        end
        clk = 1'h0;
        inc = 1'h0;
        rst = 1'h0;
        CYCLE = 0;
        rst = 1'h1;
        delay(0, RESET_CYCLE_NUMBER);

        rst = 1'h0;

        if($test$plusargs("netscen"))
            netscen = 1;
        else
            netscen = 0;

        argv = 0;
        if($value$plusargs("argv=%s", argv)) begin
        end

        if($value$plusargs("scen=%s", pstring)) begin
            $setScenario(netscen, argv, pstring);
            run = 1'h1;
        end
        else begin
            $display("Please, type a scenario name with +scen=SCEN_NAME parameter");
            run = 1'h0;
        end

        while(run) begin
            $applyAction();
            cycle(1);
            $checkAction();
        end
        cycle(1);
    end
endmodule

