/** @file fifo_msg.h
 * This file contains the reference model message classes declaration.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#pragma once

#include <hw/message.hpp>

namespace cpptesk {
namespace examples {
namespace fifo {

/// Messages for input interfaces
MESSAGE(InputData)
{
public:
    InputData();
    virtual ~InputData();

    /// Support of message cloning
    SUPPORT_CLONE(InputData);
    /// Registration of the data field (width - 8 bits)
    DECLARE_FIELD(data, 8);
};

/// Messages for output interfaces
MESSAGE(OutputData)
{
public:
    OutputData();
    OutputData(uint8_t datum);
    virtual ~OutputData();

    /// Support of message cloning
    SUPPORT_CLONE(OutputData);
    /// Registration of the data field (width - 8 bits)
    DECLARE_FIELD(data, 8);
};

}}}

